module EdgeRider
  module PreloadAssociations
    module PreloadAssociationsInstanceMethod
      def preload_associations(*args)
        self.class.preload_associations([self], *args)
      end
    end

    def preload_associations(*args)
      preloader = ActiveRecord::Associations::Preloader

      if preloader.method_defined?(:preload) # Rails 5 to Rails 6.1
        preloader.new.preload(*args)
      else # Rails 7+
        records = args.first
        associations = args.second
        options = args[2] || {}
        preloader.new(records: records, associations: associations, **options).call
      end
    end
  end
end

ActiveSupport.on_load :active_record do
  extend(EdgeRider::PreloadAssociations)
  include(EdgeRider::PreloadAssociations::PreloadAssociationsInstanceMethod)
end
